%{
create X matrix of 19 strain gauges ADC corresponding to 6 cracks and pressure  
%}

clear 
load('indata.mat');
load('myConstants.mat'); %NO_OFF_SENSOR, NO_OF_CRACK
%{ 
NO_OF_SENSOR=19
Xi[1..NO_OF_SENSOR   Pressure]=X[1.20]
Xcr0: no crack
Xcr1: crack Length x Depth 50mm x 8mm  
Xcr2: crack 100mm x 8mm 
Xcr3: crack 100mm x 18mm 
Xcr4: crack 150mm x 18mm
Xcr5: crack 180mm x 18mm 
Xcr6: crack 200mm x 18mm

%}






if  MYMODE==0 %normal
    %XCr{1}=getXdata(pristine1,NO_OF_SENSOR);
    XCr{1}=getXdata(pristine2,NO_OF_SENSOR);
    XCr{2}=getXdata(cr50mmd1,NO_OF_SENSOR);
    XCr{3}=getXdata(cr100mmd1,NO_OF_SENSOR);
    XCr{4}=getXdata(cr100mmd2,NO_OF_SENSOR);
    XCr{5}=getXdata(cr150mmd2,NO_OF_SENSOR);
    XCr{6}=getXdata(cr180mmd2,NO_OF_SENSOR);
    XCr{7}=getXdata(cr200mmd2,NO_OF_SENSOR);
    
    newMx=[8 9 10 11 12 13 14];
    oldMx=[10 14 11 8 9 12 13];

    for i=1:NO_OF_CRACK+1
        XCr{i}(:,newMx)=XCr{i}(:,oldMx);
    end
    
    Xall=cat(1,XCr{1},XCr{2});
    for i=2:NO_OF_CRACK+1
        Xall=cat(1,Xall,XCr{i});
    end

    %test error in sampling, if error!=0: recheck data
    for c=1:7
       xtest=XCr{c}(:,1);
       [row col]=size(xtest);
       r=1;
       errPos=0;
       while r<(row-100)

           x0=xtest(r);
           r=r+100;
           x1=xtest(r);
           if abs(x1-x0)<500
               errPos=i*100+1;
               break;
           end

       end
       if errPos~=0
           break;
       end
    end
    
    
    save('Xmatrix.mat','XCr','Xall','NO_OF_SENSOR','NO_OF_CRACK','-append');

elseif MYMODE==1    %check temperature
     XCrT{1}=getXdata(cr200mmd2,NO_OF_SENSOR);
    XCrT{2}=getXdata(T246oC,NO_OF_SENSOR);
    XCrT{3}=getXdata(T223oC,NO_OF_SENSOR);
    XCrT{4}=getXdata(T350oC,NO_OF_SENSOR);
    
    XCrT{5}=getXdata(T250oCD2,NO_OF_SENSOR);
    XCrT{6}=getXdata(T156oCD2,NO_OF_SENSOR);   
    
    newMx=[8 9 10 11 12 13 14];
    oldMx=[10 14 11 8 9 12 13];

    for i=1:NO_OF_CRACK+1
        XCrT{i}(:,newMx)=XCrT{i}(:,oldMx);
    end
    
    XTall=cat(1,XCrT{1},XCrT{2});
    for i=2:NO_OF_CRACK+1
        XTall=cat(1,XTall,XCrT{i});
    end
    save('Xmatrix.mat','XCrT','XTall','NO_OF_SENSOR','NO_OF_CRACK','-append');

    %{
    XCr{1}=getXdata(cr200mmd2,NO_OF_SENSOR);
    XCr{2}=getXdata(T246oC,NO_OF_SENSOR);
    XCr{3}=getXdata(T223oC,NO_OF_SENSOR);
    XCr{4}=getXdata(T350oC,NO_OF_SENSOR);
    XCr{5}=getXdata(T250oCD2,NO_OF_SENSOR);
    XCr{6}=getXdata(T156oCD2,NO_OF_SENSOR);
    %}
end 



%{
XCr0(:,newMx)=XCr0(:,oldMx);
XCr1(:,newMx)=XCr1(:,oldMx);
XCr2(:,newMx)=XCr2(:,oldMx);
XCr3(:,newMx)=XCr3(:,oldMx);
XCr4(:,newMx)=XCr4(:,oldMx);
XCr5(:,newMx)=XCr5(:,oldMx);
XCr6(:,newMx)=XCr6(:,oldMx);

XCr7(:,newMx)=XCr7(:,oldMx);
XCr8(:,newMx)=XCr8(:,oldMx);
XCr9(:,newMx)=XCr9(:,oldMx);
%}



%{
[sizeXCr0,tp1]=size(XCr0);
[sizeXCr1,tp1]=size(XCr1);
[sizeXCr2,tp1]=size(XCr2);
[sizeXCr3,tp1]=size(XCr3);
[sizeXCr4,tp1]=size(XCr4);
[sizeXCr5,tp1]=size(XCr5);
[sizeXCr6,tp1]=size(XCr6);



Xall=cat(1,XCr0,XCr1);
Xall=cat(1,Xall,XCr2);
Xall=cat(1,Xall,XCr3);
Xall=cat(1,Xall,XCr4);
Xall=cat(1,Xall,XCr5);
Xall=cat(1,Xall,XCr6);


Xall=cat(1,Xall,XCr7);
Xall=cat(1,Xall,XCr8);
Xall=cat(1,Xall,XCr9);




XCr{1}=XCr0;
XCr{2}=XCr1;
XCr{3}=XCr2;
XCr{4}=XCr3;
XCr{5}=XCr4;
XCr{6}=XCr5;
XCr{7}=XCr6;


XCr{8}=XCr7;
XCr{9}=XCr8;
XCr{10}=XCr9;
%}




%save('Xmatrix.mat','XCr0','XCr1','XCr2','XCr3','XCr4','XCr5','XCr6','Xall','NO_OF_SENSOR');

