%create average and nomalize X data 
% output XavgN0...6 (for each crack) and XAvgNAll for all data
% params: AVG_SAMPLES: number of samples to average

%if have no data, run creatX.m once before this script
% or uncomment the following lines, run then recomment it again
creatX;

clear 
load('Xmatrix.mat');
load('myConstants.mat');

if MYMODE==0
    XCal=XCr;
elseif MYMODE==1
    XCal=XCrT;
end

AVG_SAMPLES=1;

szXCal=zeros(NO_OF_CRACK+1,1);
for i=1:NO_OF_CRACK+1
    [szXCal(i),tpl]=size(XCal{i});
end

for k=1:NO_OF_CRACK+1 %scan through each crack profile
    Xtemp=XCal{k}(1:AVG_SAMPLES,:);
    Xavg{k}=zeros(1,NO_OF_SENSOR+1)+mean(Xtemp,1);
    for i=1:(szXCal(k)/AVG_SAMPLES-1)    %scan all rows
        Xtemp=XCal{k}(i*AVG_SAMPLES+1:(i+1)*AVG_SAMPLES,:);
        Xavg{k}=cat(1,Xavg{k},mean(Xtemp,1));
    end
end



XAvgAll=[];
for i=1:NO_OF_CRACK
    XAvgAll=cat(1,XAvgAll,Xavg{i});
end



%tare and normalize to pristine value

[maxP,pos1]=max(Xavg{1}(:,end)); %max and min pressure (last column)
[minP,pos0]=min(Xavg{1}(:,end));
RefRange=Xavg{1}(pos1,1:NO_OF_SENSOR)-Xavg{1}(pos0,1:NO_OF_SENSOR);
SCALE=100;
RefRange=cat(2,RefRange,SCALE); %concatenate SCALE column to the last column
RefXtare=Xavg{1}(pos0,1:NO_OF_SENSOR);
RefXtare=cat(2,RefXtare,0);

%Xnorm=(X-Xtare)/Range
for i=1:NO_OF_CRACK+1
    XavgCal{i}=(Xavg{i}-RefXtare)./RefRange*SCALE;
end



XAvgNAllCal=[];
for i=1:NO_OF_CRACK-1
    XAvgNAllCal=cat(1,XAvgNAllCal,XavgCal{i});
end



if MYMODE==0
    XavgN=XavgCal;
    XAvgNAll=XAvgNAllCal;
    %save('XAvgNmatrix.mat','XavgN','XAvgNAll','NO_OF_SENSOR','NO_OF_CRACK','-append');vinh
    save('XAvgNmatrix.mat','XavgN','XAvgNAll','NO_OF_SENSOR','NO_OF_CRACK');

elseif MYMODE==1
    XTavgN=XavgCal;
    XTAvgNAll=XAvgNAllCal;
    save('XAvgNmatrix.mat','XTavgN','XTAvgNAll','NO_OF_SENSOR','NO_OF_CRACK','-append');

end




