
% mark anomoly points (pulses caused by error by reading strain gauge)
% these pulses are mostly 1 point surge. 
% input:
%       + data
%       + sensor index
%       + surge threshold
%       + pos_Pchange and ncount in filter chap2
function [pos_SSchange,posCount]=filtStraingauges(data,ssPos, surgeThreshold,pos_PressPoint)
load('myConstants.mat');
hold on
[rangeSSArr,minArr]=drawStrainData(data,ssPos+2,ssPos,1);

ssArr=data(:,ssPos+2);
[ncount,ncount0]=size(pos_PressPoint);

%{
maxArr=max(ssArr);
minArr=min(ssArr);
rangeSSArr=maxArr-minArr;
ssArr1=(ssArr-minArr)./rangeSSArr;
hold on
plot(ssArr1+ssPos);
%}


SSchange=0;
pos_SSchange=find(ssArr<=-134217728);   %find locations of max negative value (caused by error reading of HX7111
[posCount,posCount0]=size(pos_SSchange);
if(posCount~=0)
    SSchange=1;
end

k0=1;
for i=1:ncount
   FILTER_SIZE_EACH_PR_POINT=120;
   k1=pos_PressPoint(i); 
   
   
   if (k1-k0)>FILTER_SIZE_EACH_PR_POINT
      k0=k1-FILTER_SIZE_EACH_PR_POINT;
   end
   tempSSarr=ssArr(k0:k1,1);
   
   diffSS=diff(tempSSarr); %get differential of 2 consecutive points
   
   posSS_quickchange=find(abs(diffSS)>surgeThreshold); % filter a surge by checking thresold
   [nrowSS,nrowSS0]=size(posSS_quickchange);
    for j=1:nrowSS-1
    if posSS_quickchange(j,1)==posSS_quickchange(j+1,1)-1 
           posCount=posCount+1;
           if SSchange==0
                SSchange=1;
                pos_SSchange=k0+posSS_quickchange(j+1)-1;
           else
                pos_SSchange=cat(1,pos_SSchange,k0+posSS_quickchange(j+1)-1);
           end           
    end
    end
     k0=k1;
end



hold on
ssArr1=(ssArr-minArr)./rangeSSArr;
if(posCount>0)
    for i=1:posCount
       plot(pos_SSchange(i),ssArr1( pos_SSchange(i))+ssPos,'r*');
    end
end

%pos_SSchange(1:5,1)=[1;2;3;4;5];
end %function
