% build X matrix, include 50 reading at each pressure location
% X= SS1_k SS2_k ..SS19 Pk, SSn: sensor n, Pk pressure sensor
% SSn: 50 reading at each Pk postion
%  = SS1_p1_1,SS2_p1_1..,SS19_p1_1, p1_1
%   .....
%    SS1_p1_50,SS2_p1_50..,SS19_p1_50, p1_50
%    SS1_p2_1,SS2_p2_1..,SS19_p2_1, p2_1
%   .....
%    SS1_p2_50,SS2_p2_50..,SS19_p2_50, p2_50
%   ....
%    SS1_pk_1,SS2_pk_1..,SS19_pk_1, pk_1
%   ....
%    SS1_pk_50,SS2_pk_50..,SS19_pk_50, pk_50
function X=getXdata(data1,noOfSens)
load('myConstants.mat'); %load constants
data=data1;

filtPrisAll=zeros(100,noOfSens);
filtCountAll=zeros(1,noOfSens);

dataPosPris=getPressPos(data);  %get Pressure toggle points
%plot and mark pressure toggle points
figure;
hold on;
p=data(:,2);
[ncount,ncount0]=size(dataPosPris);
[range,minData]=drawStrainData(data,2,0,1);
p1=(p-minData)./range;
for i=1:ncount
    plot(dataPosPris(i),p1(dataPosPris(i)),'r*');
end


while 1
    
    %filter anomoly data (caused by error reading)
    %result in:
    %   filtPrisAll: position of anomolly data
    %   filtCountAll: number of anomoly data of each sensors
    filtThres=1000;
    for i=1:noOfSens    
        clear x y arr
        if ismember(i,GROUP5)
            filtThres=20000;
        end
        [arr,filtCountAll(1,i)]=filtStraingauges(data,i,filtThres,dataPosPris);
        filtPrisAll(1:filtCountAll(1,i),i)=arr;
    end

    %merge all pos in every colum of filtPrisAll to 1 column in filtDataAll
    filtNo=0;
    for i=1:noOfSens
        if(filtCountAll(1,i))>0
            if(filtNo==0)
                filtNo=filtCountAll(i);
                filtDataAll=filtPrisAll(1:filtCountAll(1,i),i);
            else       
              for j=1:filtCountAll(i)
                    pos=filtPrisAll(j,i);
                    if(pos~=filtDataAll)
                        filtNo=filtNo+1;
                        filtDataAll=cat(1,filtDataAll,pos);
                    end
               end
            end

        end
    end
    filtDataAll=sort(filtDataAll,'descend');
    %remove anomoly data, store in data_2

    for i=1:filtNo
        data(filtDataAll(i),:)=[]; 
    end
    dataPosPris=getPressPos(data);  %get Pressure toggle points

    if filtNo==0
        break;
    end
end

data(:,3:noOfSens+2)=data(:,3:noOfSens+2).*(-1); %reverse strain data


% build X matrix, include "SAMPLE_SIZE_EACH_PRESSURE_POINT" samples at each pressure location
% X= SS1 SS2 ..SS19 P, SSn: sensor n, P pressure sensor
% SS1: 50 reading at each P postion, with location in dataPosPris_2
%  = SS1_p1_1,SS2_p1_1..,SS19_p1_1, p1_1
%   .....
%    SS1_p1_50,SS2_p1_50..,SS19_p1_50, p1_50
%    SS1_p2_1,SS2_p2_1..,SS19_p2_1, p2_1
%   .....
%    SS1_p2_50,SS2_p2_50..,SS19_p2_50, p2_50
%   ....
%    SS1_pk_1,SS2_pk_1..,SS19_pk_1, pk_1
%   ....
%    SS1_pk_50,SS2_pk_50..,SS19_pk_50, pk_50
[pCnt,pCnt0]=size(dataPosPris);
X=[];
for i=1:pCnt
    pos1=dataPosPris(i);
    pos0=pos1-SAMPLE_SIZE_EACH_PRESSURE_POINT+1;
    if pos0 <1
        pos0=1;
    end
    %tempArr=data_2(pos0:pos1,:);
    tempArr=[data(pos0:pos1,3:noOfSens+2),data(pos0:pos1,2)];
    X=cat(1,X,tempArr);
end




figure;
hold on
for i=1:noOfSens+1
    drawStrainData(X,i,i,1);
end
hold off

end