clear
load('XtrainRand.mat');
load('Ymatrix.mat');

NO_OF_SENSOR=19;





SlopeStrain=zeros(NO_OF_CRACK+1,NO_OF_SENSOR);
OffsetStrain=zeros(NO_OF_CRACK+1,NO_OF_SENSOR);
RsqStrain=zeros(NO_OF_CRACK+1,NO_OF_SENSOR);

SlopeStrain=zeros(6,NO_OF_SENSOR);
for k=1:NO_OF_CRACK+1
    x=XTrain{k}(:,end);
    for i=1:NO_OF_SENSOR
        y=XTrain{k}(:,i);    
        p = polyfit(x,y,1);
        yfit = polyval(p,x);
        yresid = y - yfit;
        SSresid = sum(yresid.^2);
        SStotal = (length(y)-1) * var(y);
        rsq = 1 - SSresid/SStotal;

        SlopeStrain(k,i)=p(1);
        OffsetStrain(k,i)=p(2);
        RsqStrain(k,i)=rsq;

        
        %for test

        % Create figure
        if ((i==19)||(i==1))&&(k==2)
                    figure1 = figure;

            % Create axes
            axes1 = axes('Parent',figure1);
            hold(axes1,'on');
            hold on
            plot(x,y,'bo');
            plot(x,yfit,'k-');
            % Create ylabel
            ylabel({'Normalize strain ADC (%)'});
    
            % Create xlabel
            xlabel({'P(mbar)'});
            hold(axes1,'off');
            % Create textbox
            if OffsetStrain(k,i)<0
                signOff='-';
            else
                signOff='+';
            end
            annotation(figure1,'textbox',...
                [0.234928571428571 0.576190476190477 0.254714285714286 0.114285714285716],...
                'String',{['y=' num2str(SlopeStrain(k,i),4) signOff num2str(abs(OffsetStrain(k,i)),4)] ...
                ,['Rsquare=' num2str(RsqStrain(k,i),4)]},...
                'FontSize',11,...
                'FitBoxToText','off');
        end
        
    end
end
%cr1



ref=SlopeStrain(1,:);
perChange=zeros(NO_OF_CRACK+1,NO_OF_SENSOR);
for i=2:NO_OF_CRACK+1
   chk=SlopeStrain(i,:);
   perChange(i,:)=(chk-ref)./ref.*100;
end
%createfigure(perChange,2,7);


ref=SlopeStrain(1,:);
perChangeDiff=zeros(NO_OF_CRACK+1,NO_OF_SENSOR);
for i=2:NO_OF_CRACK+1
   chk=SlopeStrain(i,:);
   ref=SlopeStrain(i-1,:);
   perChangeDiff(i,:)=(chk-ref)./ref.*100;
end
%createfigure(perChangeDiff,1,1);







testSize=100;
regScale=0.5;

for m=1:NO_OF_CRACK+1
    xTest=XTest{m}(:,end);
    yTest=XTest{m}(:,1:NO_OF_SENSOR);
    [s1,tp1]=size(xTest);
    regSize=round(s1*regScale);
    slopeTest=zeros(testSize,1);
    slopeRef=repmat(SlopeStrain(m,:),testSize,1);
    for k=1:testSize
        p=randperm(s1,regSize)';
        x=xTest(p);
        yTestOrg=yTest(p,:);

        for i=1:NO_OF_SENSOR
            y=yTestOrg(:,i);    
            p = polyfit(x,y,1);
           slopeTest(k,i)=p(1);
        end
    end

    errSlope{m}=(slopeTest-slopeRef)./slopeRef.*100;
end 

save('SlopeChange.mat','perChange','perChangeDiff','NO_OF_SENSOR','NO_OF_CRACK');

